#include <iostream>
#include <random>
#include <ctime>

int main(){
    std::random_device rd; // 用于获取非确定性随机种子

    std::mt19937 generator(rd()); // 使用更好的随机种子初始化mt19937
    std::cout << generator() << std::endl;

    std::ranlux24_base rlbGenerator(rd()); // 使用更好的随机种子初始化ranlux24_base
    std::cout << rlbGenerator() << std::endl;

    std::knuth_b knuthGenerator(rd()); // 使用更好的随机种子初始化knuth_b
    std::cout << knuthGenerator() << std::endl;

    return 0;
}