import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;

@Slf4j
@RestController
@RequestMapping("/file")
public class UploadFileVerifyRule {

    //文件磁盘路径
    @Value("${files.upload.path}")
    private String fileUploadPath;

    @PostMapping("/upload")
    public String upload(@RequestParam MultipartFile file) throws IOException { // Noncompliant {{程序设计时，应以“白名单”方式限制允许用户上传的文件的类型}}



        long size = file.getSize();
        if(size > 100){

        }
        //获取文件原始名称
        String originalFilename = file.getOriginalFilename();
        String type = FileUtil.extName(originalFilename);
//        if(type == ""){
//
//        }

        File localFile = new File(fileUploadPath + File.separator + originalFilename);

        localFile.setExecutable(true);
        localFile.setReadable(true);
        localFile.setWritable(true);

        file.transferTo(localFile);
        return "上传成功";
    }

    class FileUtil{
        public static String extName(String filename){
            // 根据文件名获取文件后缀
            return filename.substring(filename.lastIndexOf(".") + 1);
        }
    }
}