import com.fasterxml.classmate.Filter;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

public class UserStatusVerifyChecker {

    private static final long serialVersionUID = 1391640560504378168L;

    static class UserService {
        public static boolean validate(String username, String password) {
            return true;
        }
    }

    public class AuthenticationFilter implements Filter {
        public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException, ServletException {// Noncompliant {{对用户进行身份鉴别并建立一个新的会话时让原来的会话失效}}
            HttpServletRequest request = (HttpServletRequest) req;
            boolean isValidUser = false;
//            String username = request.getParameter("username");
//            String password = request.getParameter("password");
//            isValidUser = UserService.validate(username, password);
            if (isValidUser) {
                HttpSession oldSession = request.getSession(false);
                if (oldSession != null) {
                    oldSession.invalidate();
                }
                HttpSession newSession = request.getSession(true);
                newSession.setMaxInactiveInterval(30 * 60);
                newSession.setAttribute("username", username);
                chain.doFilter(req, resp); // 继续执行下一个过滤器或请求
            } else {
                req.getRequestDispatcher("/login.jsp").forward(req, resp); // 跳转到登录页面
            }
        }

        @Override
        public boolean include(Object o) {
            return false;
        }
    }

    public class AuthenticationInterceptor extends HandlerInterceptorAdapter {
        @Override
        public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {// Noncompliant {{对用户进行身份鉴别并建立一个新的会话时让原来的会话失效}}
            boolean isValidUser = false;
            String username = request.getParameter("username");
            String password = request.getParameter("password");
            isValidUser = UserService.validate(username, password);
            if (isValidUser) {
//                HttpSession oldSession = request.getSession(false);
                if (oldSession != null) {
                    oldSession.invalidate();
                }
                HttpSession newSession = request.getSession(true);
                newSession.setMaxInactiveInterval(30 * 60);
                newSession.setAttribute("username", username);
                return true; // 继续下一个拦截器或请求处理器
            } else {
                response.sendRedirect("/login.jsp"); // 跳转到登录页面
                return false;
            }
        }
    }
}